"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const React = tslib_1.__importStar(require("react"));
const react_native_1 = require("react-native");
const moment_1 = tslib_1.__importDefault(require("moment"));
const momentDurationFormatSetup = require("moment-duration-format");
momentDurationFormatSetup(moment_1.default);
/**
 * ? Local Imports
 */
const Countdown_style_1 = tslib_1.__importDefault(require("./Countdown.style"));
class Countdown extends React.Component {
    constructor(props) {
        super(props);
        this.interval = null;
        this.state = {
            hours: "",
            minutes: "",
            seconds: "",
            timer: undefined,
            countdown: props.defaultCountdown || "- : - : -",
        };
    }
    componentDidMount() {
        const { start = moment_1.default(), end = moment_1.default(), format = "hh:mm:ss", } = this.props;
        this.interval = setInterval(() => {
            const countDownStart = start.add(1, "second");
            const then = moment_1.default(countDownStart).format("DD/MM/YYYY HH:mm:ss");
            const now = moment_1.default(end).format("DD/MM/YYYY HH:mm:ss");
            const ms = moment_1.default(now, "DD/MM/YYYY HH:mm:ss").diff(moment_1.default(then, "DD/MM/YYYY HH:mm:ss"));
            const duration = moment_1.default.duration(ms);
            const countdown = duration.format(format);
            if (ms <= 0) {
                this.setState({ hours: "00", minutes: "00", seconds: "00" });
                clearInterval(this.interval);
            }
            else {
                this.setState({ countdown: countdown });
            }
        }, 1000);
    }
    componentDidUpdate() {
        if (this.state.timer === 1) {
            const { onCountdownOver } = this.props;
            onCountdownOver && onCountdownOver();
            clearInterval(this.interval);
            this.forceUpdate();
        }
    }
    componentWillUnmount() {
        clearInterval(this.interval);
    }
    render() {
        const { textStyle } = this.props;
        const { countdown } = this.state;
        return (<react_native_1.Text style={[Countdown_style_1.default.textStyle, textStyle]} {...this.props}>
        {countdown}
      </react_native_1.Text>);
    }
}
exports.default = Countdown;
//# sourceMappingURL=Countdown.js.map